﻿using System;
using System.IO;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.Text;
using System.Web;
using System.Web.Caching;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Infragistics.WebUI.UltraWebGrid;
using Infragistics.WebUI.UltraWebCalcManager;
using Infragistics.WebUI.WebDataInput;
using System.Data.SqlClient;
using Researcher.Common.CustomMembership;
using Researcher.Common.Exceptions;
using Researcher.Common;

namespace Researcher.App
{
    public partial class Queries : System.Web.UI.Page
    {
        protected ResearcherMembershipUser rUser;
        protected Int32? SubscriberId;
        protected String loggedInUserRole;
        protected Boolean isSuperAdmin;
        protected string sUserID;
        protected Int32 iDBID;
        protected Boolean isStageDB;
        protected Int32 iElementCount;
        protected Int32 iQueryType;
        protected Boolean bPivot;
        protected Boolean bShowTotals;

        protected void Page_Load(object sender, EventArgs e)
        {
            rUser = Membership.GetUser() as ResearcherMembershipUser;
            SubscriberId = rUser.Subscriber.Id;
            loggedInUserRole = Roles.GetRolesForUser()[0];
            isSuperAdmin = loggedInUserRole == Common.Strings.RoleName.SuperAdmin;
            sUserID = rUser.ProviderUserKey.ToString();
            iDBID = (int)SessionWrapper.DatasetId;
            isStageDB = SessionWrapper.IsStageDB;

            if (!IsPostBack)
            {
                //fill query type dropdown
                ddlQueryType.DataSource = Util.GetQueryTypes();
                ddlQueryType.DataTextField = "Text";
                ddlQueryType.DataValueField = "Value";
                ddlQueryType.DataBind();
                ddlQueryType.Columns[1].Hidden = true;
                ddlQueryType.SelectedIndex = 0;

                //fill company dropdown
                ddlCompany.DataSource = GetData.getCompanyList();
                ddlCompany.DataTextField = "Text";
                ddlCompany.DataValueField = "Value";
                ddlCompany.DataBind();
                ddlCompany.Columns[1].Hidden = true;
                ddlCompany.SelectedIndex = -1;

                //fill company groups dropdown
                ddlCompanies.DataSource = GetData.getCompanyGroups(false);
                ddlCompanies.DataTextField = "Text";
                ddlCompanies.DataValueField = "Value";
                ddlCompanies.DataBind();
                ddlCompanies.Columns[1].Hidden = true;
                ddlCompanies.Columns[2].Hidden = true;
                ddlCompanies.SelectedIndex = -1;

                //fill field groups dropdown
                ddlFields.DataSource = GetData.getFieldGroups();
                ddlFields.DataTextField = "Text";
                ddlFields.DataValueField = "Value";
                ddlFields.DataBind();
                ddlFields.Columns[1].Hidden = true;
                ddlFields.Columns[2].Hidden = true;
                ddlFields.SelectedIndex = -1;

                //fill periods dropdown
                ddlPeriods.DataSource = GetData.getPeriods(false);
                ddlPeriods.DataTextField = "Text";
                ddlPeriods.DataValueField = "Value";
                ddlPeriods.DataBind();
                ddlPeriods.Columns[1].Hidden = true;
                ddlPeriods.Columns[2].Hidden = true;
                ddlPeriods.Columns[3].Hidden = true;
                ddlPeriods.Columns[4].Hidden = true;
                ddlPeriods.SelectedIndex = -1;

                //fill pages dropdown
                ddlPages.DataSource = GetData.GetDPPages();
                ddlPages.DataTextField = "Text";
                ddlPages.DataValueField = "Value";
                ddlPages.DataBind();
                ddlPages.Columns[1].Hidden = true;
                ddlPages.SelectedIndex = -1;

                //fill total type dropdown
                ddlTotalType.DataSource = GetData.GetTotalTypes();
                ddlTotalType.DataTextField = "Text";
                ddlTotalType.DataValueField = "Value";
                ddlTotalType.DataBind();
                ddlTotalType.Columns[1].Hidden = true;
                ddlTotalType.DataValue = SessionWrapper.TotalType;
                ddlTotalType.DisplayValue = SessionWrapper.TotalType;

                hidTotalType.Value = SessionWrapper.TotalType;

                wibShowTotals.Text = (SessionWrapper.ShowTotals == 1) ? "Totals: ON" : "Totals: OFF";

                string sAltColor = "#" + SessionWrapper.AltRowColour;
                hidAltColor.Value = sAltColor;
                colorpicker1.Style.Value = "border-style: solid; border-width: 1px; width: 50px; height: 18px; cursor: hand; vertical-align: middle; background-color:" + sAltColor + ";";
            }
        }

        protected void warpCompanies_ContentRefresh(object sender, EventArgs e)
        {
            //fill field dropdown
            ddlCompanies.DataSource = GetData.getCompanyGroups(false);
            ddlCompanies.DataTextField = "Text";
            ddlCompanies.DataValueField = "Value";
            ddlCompanies.DataBind();
            ddlCompanies.Columns[1].Hidden = true;
            ddlCompanies.Columns[2].Hidden = true;
        }

        protected void ddlCompanies_InitializeRow(object sender, Infragistics.WebUI.UltraWebGrid.RowEventArgs e)
        {
            foreach (UltraGridRow row in ddlCompanies.Rows)
            {
                switch (row.Cells[2].Text)
                {
                    case "-1":
                        row.Style.ForeColor = Color.Blue;
                        break;
                    case "0":
                        row.Style.ForeColor = Color.Black;
                        break;
                    case "1":
                        row.Style.ForeColor = Color.DarkGreen;
                        break;
                }
            }
        }

        protected void warpFields_ContentRefresh(object sender, EventArgs e)
        {
            //fill field dropdown
            ddlFields.DataSource = GetData.getFieldGroups();
            ddlFields.DataTextField = "Text";
            ddlFields.DataValueField = "Value";
            ddlFields.DataBind();
            ddlFields.Columns[1].Hidden = true;
            ddlFields.Columns[2].Hidden = true;
        }

        protected void ddlFields_InitializeRow(object sender, Infragistics.WebUI.UltraWebGrid.RowEventArgs e)
        {
            foreach (UltraGridRow row in ddlFields.Rows)
            {
                switch (row.Cells[2].Text)
                {
                    case "-1":
                        row.Style.ForeColor = Color.Blue;
                        break;
                    case "0":
                        row.Style.ForeColor = Color.Black;
                        break;
                    case "1":
                        row.Style.ForeColor = Color.DarkGreen;
                        break;
                }
            }
        }

        protected void warpField_ContentRefresh(object sender, EventArgs e)
        {
            //fill field dropdown
            ddlField.DataSource = GetData.GetFields(ddlPages.DataValue.ToString());
            ddlField.DataTextField = "Text";
            ddlField.DataValueField = "Value";
            ddlField.DataBind();
            ddlField.Columns[1].Hidden = true;
            ddlField.Columns[2].Hidden = true;
            ddlField.Columns[3].Hidden = true;
            ddlField.Columns[4].Hidden = true;
            ddlField.SelectedIndex = -1;
        }

        protected void ddlField_InitializeRow(object sender, Infragistics.WebUI.UltraWebGrid.RowEventArgs e)
        {
            foreach (UltraGridRow row in ddlField.Rows)
            {
                switch (row.Cells[2].Text)
                {
                    case "-1":
                        row.Style.ForeColor = Color.Blue;
                        break;
                    case "0":
                        row.Style.ForeColor = Color.Black;
                        break;
                    case "1":
                        row.Style.ForeColor = Color.DarkGreen;
                        break;
                }
            }
        }

        protected void ugQryResults_InitializeLayout(object sender, LayoutEventArgs e)
        {
            DataTable dtCols = new DataTable();

            //Setup First Columns
            int iCols = 0;
            UltraGridColumn c0 = ugQryResults.DisplayLayout.Bands[0].Columns[iCols];
            c0.Key = "Code";
            c0.Header.Caption = "Code";
            c0.Hidden = true;
            c0.Header.Style.HorizontalAlign = HorizontalAlign.Left;
            c0.Footer.Caption = "Code";
            c0.Footer.Style.HorizontalAlign = HorizontalAlign.Left;
            iCols++;
            UltraGridColumn c = ugQryResults.DisplayLayout.Bands[0].Columns[iCols];
            switch (bPivot)
            {
                case false:
                    dtCols = SessionWrapper.QueryColumns;
                    switch (iQueryType)
                    {
                        case 1:
                            c.Key = "Company";
                            c.Width = Unit.Pixel(200);
                            c.Header.Caption = "Company";
                            break;
                        case 2:
                            c.Key = "Year";
                            c.Width = Unit.Pixel(75);
                            c.Header.Caption = "Year";
                            break;
                        case 3:
                            c.Key = "Company";
                            c.Width = Unit.Pixel(200);
                            c.Header.Caption = "Company";
                            break;
                    }
                    break;
                case true:
                    dtCols = SessionWrapper.QueryRows;
                    if (hidFilter.Value == "Filter")
                    {
                        DataTable dtFilterCols = dtCols.Clone();
                        foreach (UltraGridRow ugrFilter in ugQryResults.Rows)
                        {
                            String sGridCode = ugrFilter.Cells[0].Text;
                            foreach (DataRow drCols in dtCols.Rows)
                            {
                                String sDTCode = drCols["Value"].ToString();
                                if (sDTCode == sGridCode)
                                {
                                    DataRow row = dtFilterCols.NewRow();
                                    row.ItemArray = drCols.ItemArray;
                                    dtFilterCols.Rows.Add(row);
                                }
                            }
                        }
                        dtCols = dtFilterCols;
                    }
                    switch (iQueryType)
                    {
                        case 1:
                            c.Key = "Field";
                            c.Width = Unit.Pixel(200);
                            c.Header.Caption = "Field";
                            break;
                        case 2:
                            c.Key = "Field";
                            c.Width = Unit.Pixel(200);
                            c.Header.Caption = "Field";
                            break;
                        case 3:
                            c.Key = "Year";
                            c.Width = Unit.Pixel(75);
                            c.Header.Caption = "Year";
                            break;
                    }
                    break;
            }
            c.Header.Style.HorizontalAlign = HorizontalAlign.Left;
            c.Footer.Caption = hidTotalType.Value;
            c.Footer.Style.HorizontalAlign = HorizontalAlign.Left;

            //Setup Subsequent Columns
            Int32 iDec = 0;
            Boolean bTotal = false;
            String sDataType = "T";
            if (iQueryType == 3)
            {
                DataRow drFldProp = GetData.GetFieldProperties(Convert.ToInt32(ddlField.DataValue)).Rows[0];
                iDec = Convert.ToInt32(drFldProp["Decimals"]);
                bTotal = Convert.ToBoolean(drFldProp["Total"]);
                sDataType = drFldProp["DataType"].ToString();
            }
            foreach (DataRow dr in dtCols.Rows)
            {
                iCols++;
                c = ugQryResults.DisplayLayout.Bands[0].Columns[iCols];
                c.Header.Style.HorizontalAlign = HorizontalAlign.Left;
                String sHeaderText = dr["Text"].ToString();
                String sHeaderKey = dr["Value"].ToString();
                c.Key = sHeaderKey;
                c.Header.Caption = sHeaderText;
                if (iQueryType != 3)
                {
                    iDec = Convert.ToInt32(dr["Decimals"]);
                    bTotal = Convert.ToBoolean(dr["Total"]);
                    sDataType = dr["DataType"].ToString();
                }

                //Setup Column Formatting for non-Pivot
                if (!bPivot)
                {
                    String sFormat = "###,###,##0";
                    if (iDec > 0)
                    {
                        sFormat += ".";
                        for (int i = 1; i <= iDec; i++)
                        {
                            sFormat += "0";
                        }
                    }

                    c.DataType = (sDataType == "T") ? "System.String" : "System.Double";
                    c.Format = (sDataType == "T") ? "" : sFormat;
                    c.CellStyle.HorizontalAlign = (sDataType == "T") ? HorizontalAlign.Left : HorizontalAlign.Right;

                    //Setup Total Footer Row
                    if (bShowTotals && bTotal)
                    {
                        c.Footer.Key = sHeaderKey + "_Total";
                        c.Footer.Style.HorizontalAlign = HorizontalAlign.Right;
                        c.Footer.Total = GetData.GetSummaryInfo(hidTotalType.Value);
                        c.Footer.Formula = "ROUND(" + hidTotalType.Value + "([" + sHeaderKey + "])," + iDec.ToString() + ")";
                    }
                }
            }

            ugQryResults.DisplayLayout.EnableInternalRowsManagement = true;
            ugQryResults.DisplayLayout.CellClickActionDefault = CellClickAction.RowSelect;
            ugQryResults.DisplayLayout.GridLinesDefault = UltraGridLines.Both;
            ugQryResults.DisplayLayout.AllowColSizingDefault = AllowSizing.Free;

            /********** The reason for the cell alignment being off ***********/
            ugQryResults.DisplayLayout.UseFixedHeaders = true;
            /******************************************************************/
            ugQryResults.Bands[0].Columns[0].Header.Fixed = true;
            ugQryResults.Bands[0].Columns[1].Header.Fixed = true;
            ugQryResults.DisplayLayout.StationaryMargins = (bShowTotals) ? StationaryMargins.HeaderAndFooter : StationaryMargins.Header;
            ugQryResults.Bands[0].ColFootersVisible = (bShowTotals) ? ShowMarginInfo.Yes : ShowMarginInfo.No;
            ugQryResults.DisplayLayout.FixedHeaderIndicatorDefault = FixedHeaderIndicator.Button;

            //Set some grid properties based on whether the grid is Pivoted or not
            if (bPivot)
            {
                ugQryResults.DisplayLayout.AllowSortingDefault = AllowSorting.No;
                ugQryResults.DisplayLayout.SortCaseSensitiveDefault = Infragistics.WebUI.Shared.DefaultableBoolean.False;
                ugQryResults.DisplayLayout.HeaderClickActionDefault = HeaderClickAction.Select;

                //ugQryResults.DisplayLayout.FilterOptionsDefault.AllowRowFiltering = RowFiltering.No;
                //ugQryResults.DisplayLayout.FilterOptionsDefault.FilterRowView = RowLocation.Top;
                //ugQryResults.DisplayLayout.FilterOptionsDefault.FilterUIType = FilterUIType.FilterRow;
                //ugQryResults.DisplayLayout.FilterOptionsDefault.RowFilterMode = RowFilterMode.AllRowsInBand;
                //ugQryResults.Bands[0].FilterOptions.FilterRowStyle.HorizontalAlign = HorizontalAlign.Left;
                //ugQryResults.Bands[0].FilterOptions.FilterRowStyle.VerticalAlign = VerticalAlign.Middle;
            }
            else
            {
                ugQryResults.DisplayLayout.AllowSortingDefault = (iElementCount > 4500) ? AllowSorting.Yes : AllowSorting.OnClient;
                ugQryResults.DisplayLayout.SortCaseSensitiveDefault = Infragistics.WebUI.Shared.DefaultableBoolean.True;
                ugQryResults.DisplayLayout.HeaderClickActionDefault = HeaderClickAction.SortMulti;

                //ugQryResults.DisplayLayout.FilterOptionsDefault.AllowRowFiltering = RowFiltering.OnServer;
                //ugQryResults.DisplayLayout.FilterOptionsDefault.FilterRowView = RowLocation.Top;
                //ugQryResults.DisplayLayout.FilterOptionsDefault.FilterUIType = FilterUIType.FilterRow;
                //ugQryResults.DisplayLayout.FilterOptionsDefault.RowFilterMode = RowFilterMode.AllRowsInBand;
                //ugQryResults.Bands[0].FilterOptions.FilterRowStyle.HorizontalAlign = HorizontalAlign.Left;
                //ugQryResults.Bands[0].FilterOptions.FilterRowStyle.VerticalAlign = VerticalAlign.Middle;
            }

            Int32 iRed = Convert.ToInt32(hidAltColor.Value.Substring(1, 2), 16);
            Int32 iGreen = Convert.ToInt32(hidAltColor.Value.Substring(3, 2), 16);
            Int32 iBlue = Convert.ToInt32(hidAltColor.Value.Substring(5, 2), 16);
            Color cAltRow = Color.FromArgb(255, iRed, iGreen, iBlue);
            ugQryResults.DisplayLayout.RowAlternateStyleDefault.BackColor = cAltRow;
            ugQryResults.DisplayLayout.RowStyleDefault.BackColor = Color.White;
        }

        protected void ugQryResults_InitializeRow(object sender, Infragistics.WebUI.UltraWebGrid.RowEventArgs e)
        {
            foreach (UltraGridCell cell in e.Row.Cells)
            {
                if (bPivot)
                {
                    String sVal = (cell.Value == null) ? "" : cell.Value.ToString();
                    String sDTDec = "";
                    if (sVal == "")
                    {
                        sDTDec = "T0";
                    }
                    else
                    {
                        sDTDec = sVal.Substring(1, 2);
                        sVal = sVal.Substring(4);
                    }
                    String sDataType = sDTDec.Substring(0, 1);
                    int iDec = Convert.ToInt32(sDTDec.Substring(1, 1));

                    switch (sDataType)
                    {
                        case "N":
                            if (sVal == "#Err")
                            {
                                cell.Value = sVal;
                            }
                            else
                            {
                                if (sVal == "") sVal = "0";
                                String sFormat = "###,###,##0";
                                if (iDec > 0)
                                {
                                    sFormat += ".";
                                    for (int i = 1; i <= iDec; i++)
                                    {
                                        sFormat += "0";
                                    }
                                }
                                cell.Value = System.String.Format("{0:" + sFormat + "}", Math.Round(Convert.ToDouble(sVal), iDec));
                            }
                            cell.Style.HorizontalAlign = HorizontalAlign.Right;
                            break;
                        case "Y":
                            cell.Value = System.String.Format("{0:0000.0}", Math.Round(Convert.ToDouble(sVal), iDec));
                            cell.Style.HorizontalAlign = HorizontalAlign.Right;
                            break;
                        case "T":
                            cell.Value = sVal;
                            cell.Style.HorizontalAlign = HorizontalAlign.Left;
                            break;
                    }
                }

                if (cell.Value != null)
                {
                    if (cell.Value.ToString() == "#Err")
                    {
                        cell.Style.BackColor = Color.Red;
                    }
                }
            }
        }

        protected void ugQryResults_DataBinding(object sender, System.EventArgs e)
        {
            DataTable dtValues = new DataTable();
            DataTable dtDPProps = new DataTable();
            Int32 iCols = 0;
            Int32 iRows = 0;

            if (hidClearFillGrid.Value == "Clear")
            {
                ugQryResults.Clear();
            }
            else
            {
                if (hidClearFillGrid.Value == "Fill")
                {
                    String s0thCol = "Code";
                    String s1stCol = "";
                    String sConst = "";
                    String sVar1 = "", sVar2 = "", sVar3 = "", sQ3Join = "";
                    String qryDPData = Util.GetQueryScript(iQueryType);
                    DataTable dtRows = new DataTable();
                    DataTable dtColumns = new DataTable();
                    SessionWrapper.QueryDataset = new DataTable();
                    SessionWrapper.FilteredDataset = new DataTable();

                    switch (iQueryType)
                    {
                        case 1:
                            sVar1 = ddlCompanies.DataValue.ToString();
                            sVar2 = ddlFields.DataValue.ToString();
                            sVar3 = ddlPeriods.DataValue.ToString();
                            dtRows = GetData.getGroupCompanies(sVar1);
                            dtColumns = GetData.getGroupFields(sVar2);
                            s1stCol = "Company";
                            sConst = sVar3;
                            break;
                        case 2:
                            sVar1 = ddlCompany.DataValue.ToString();
                            sVar2 = ddlFields.DataValue.ToString();
                            dtRows = GetData.getPeriods(false);
                            dtColumns = GetData.getGroupFields(sVar2);
                            s1stCol = "Year";
                            sConst = sVar1;
                            break;
                        case 3:
                            sVar1 = ddlCompanies.DataValue.ToString();
                            sVar2 = ddlField.DataValue.ToString();
                            sQ3Join = (ddlField.SelectedRow.Cells[2].Value.ToString() == "D") ? "left outer join Period p on p.Period=dp.Year" : "cross join Period p";
                            qryDPData = qryDPData.Replace("[Q3JOIN]", sQ3Join);
                            dtRows = GetData.getGroupCompanies(sVar1);
                            dtColumns = GetData.getPeriods(false);
                            s1stCol = "Company";
                            sConst = sVar2;
                            dtDPProps = GetData.GetFieldProperties(Convert.ToInt32(ddlField.DataValue));
                            break;
                    }

                    SessionWrapper.QueryDataset.Columns.Add(s0thCol, typeof(String));
                    SessionWrapper.QueryDataset.Columns.Add(s1stCol, typeof(String));
                    iCols = 1;
                    foreach (DataRow drCol in dtColumns.Rows)
                    {
                        iCols++;
                        DataColumn column = new DataColumn();
                        column.ColumnName = drCol["Text"].ToString();
                        column.DataType = (drCol["Text"].ToString() == "N") ? typeof(Decimal) : typeof(String);
                        SessionWrapper.QueryDataset.Columns.Add(column);
                    }

                    String sCompCode = "";
                    Int32 iDataPoint = 0;
                    Double nPeriod = 0.0;
                    iRows = 0;

                    DataTable dtDPData = new DataTable();
                    DataColumn[] keys = new DataColumn[3];
                    DataColumn dpcol;
                    dpcol = new DataColumn();
                    dpcol.ColumnName = "Code";
                    dpcol.DataType = typeof(String);
                    keys[0] = dpcol;
                    dtDPData.Columns.Add(dpcol);
                    dpcol = new DataColumn();
                    dpcol.ColumnName = "Year";
                    dpcol.DataType = typeof(Decimal);
                    keys[1] = dpcol;
                    dtDPData.Columns.Add(dpcol);
                    dpcol = new DataColumn();
                    dpcol.ColumnName = "DataPoint";
                    dpcol.DataType = typeof(Int32);
                    keys[2] = dpcol;
                    dtDPData.Columns.Add(dpcol);
                    dtDPData.Columns.Add("Value", typeof(String));
                    dtDPData.Columns.Add("FieldType", typeof(String));
                    dtDPData.Columns.Add("DataType", typeof(String));
                    dtDPData.Columns.Add("Decimals", typeof(Int32));
                    dtDPData.Columns.Add("Formula", typeof(String));
                    dtDPData.PrimaryKey = keys;
                    String connectionString = Settings.GetDatabaseConnectionString(iDBID);
                    using (SqlConnection myConnection = new SqlConnection(connectionString))
                    {
                        myConnection.Open();
                        using (SqlCommand cmd = new SqlCommand(qryDPData, myConnection))
                        {
                            cmd.CommandTimeout = 120;
                            cmd.Parameters.Clear();
                            cmd.Parameters.AddWithValue("@var1", sVar1);
                            cmd.Parameters.AddWithValue("@var2", sVar2);
                            cmd.Parameters.AddWithValue("@var3", sVar3);
                            SqlDataReader rdr = cmd.ExecuteReader();

                            while (rdr.Read())
                            {
                                DataRow row = dtDPData.NewRow();
                                row["Code"] = rdr["Code"].ToString();
                                row["Year"] = Convert.ToDecimal(rdr["Year"]);
                                row["DataPoint"] = Convert.ToInt32(rdr["DataPoint"]);
                                row["Value"] = rdr["Value"].ToString();
                                row["FieldType"] = rdr["FieldType"].ToString();
                                row["DataType"] = rdr["DataType"].ToString();
                                row["Decimals"] = Convert.ToInt32(rdr["DecimalPlaces"]);
                                row["Formula"] = rdr["Formula"].ToString();
                                dtDPData.Rows.Add(row);
                            }
                        }
                    }

                    foreach (DataRow drRow in dtRows.Rows)
                    {
                        iRows++;
                        DataRow row = SessionWrapper.QueryDataset.NewRow();
                        row[s0thCol] = drRow["Value"];
                        row[s1stCol] = drRow["Text"];
                        iCols = 1;

                        foreach (DataRow drCol in dtColumns.Rows)
                        {
                            iCols++;
                            String sColName = drCol["Text"].ToString();
                            switch (iQueryType)
                            {
                                case 1:
                                    sCompCode = drRow["Value"].ToString();
                                    iDataPoint = Convert.ToInt32(drCol["Value"]);
                                    nPeriod = Convert.ToDouble(sConst);
                                    break;
                                case 2:
                                    sCompCode = sConst;
                                    iDataPoint = Convert.ToInt32(drCol["Value"]);
                                    nPeriod = Convert.ToDouble(drRow["Value"]);
                                    break;
                                case 3:
                                    sCompCode = drRow["Value"].ToString();
                                    iDataPoint = Convert.ToInt32(sConst);
                                    nPeriod = Convert.ToDouble(drCol["Value"]);
                                    break;
                            }
                            object[] aFilter = new object[3];
                            aFilter[0] = sCompCode;
                            aFilter[1] = nPeriod;
                            aFilter[2] = iDataPoint;
                            DataRow drDPData = dtDPData.Rows.Find(aFilter);

                            if (drDPData == null)
                            {
                                if (dtDPProps.Rows[0]["DataType"].ToString() == "N")
                                {
                                    row[sColName] = 0;
                                }
                            }
                            else
                            {
                                String sType = drDPData["FieldType"].ToString();
                                Int32 iDecmls = Convert.ToInt32(drDPData["Decimals"]);
                                String sDataType = drDPData["DataType"].ToString();

                                if (sType == "C")
                                {
                                    String sFormula = drDPData["Formula"].ToString();
                                    String sVal = GetData.GetCalcedData(sFormula, sCompCode, nPeriod);
                                    try
                                    {
                                        row[sColName] = Math.Round(UltraWebCalcManager1.Calculate(sVal).ToDecimal(),iDecmls);
                                    }
                                    catch (Exception ex)
                                    {
                                        row[sColName] = "#Err";
                                        Console.WriteLine(ex.Message);
                                    }
                                }
                                else
                                {
                                    if (sDataType == "N")
                                    {
                                        row[sColName] = (drDPData["Value"].ToString() == "") ? 0 : drDPData["Value"];
                                    }
                                    else
                                    {
                                        row[sColName] = (drDPData["Value"].ToString() == "") ? "" : drDPData["Value"];
                                    }
                                }
                            }
                        }
                        SessionWrapper.QueryDataset.Rows.Add(row);
                    }

                    SessionWrapper.QueryColumns = dtColumns;
                    SessionWrapper.QueryRows = dtRows;
                    dtValues = SessionWrapper.QueryDataset;
                }
                else if (hidClearFillGrid.Value == "ApplyFilter")
                {
                    //create filter condition table, to calculate rows compliance with filter
                    Int32 iCond = -1;
                    String sOR = "OR(";
                    String sAND = "AND(";
                    String sFilter = "";
                    String pAndOr = "";
                    String p2AndOr = "";
                    String sCond = "";
                    Boolean bHasOR = false;
                    Boolean bFilterFailed = false;
                    foreach (UltraGridRow ugrFilter in ugFilter.Rows)
                    {
                        String sFldName = ugrFilter.Cells[0].Text;
                        String sMatch = ugrFilter.Cells[1].Text;
                        String sValue = ugrFilter.Cells[2].Text;
                        String sAndOr = "" + ugrFilter.Cells[3].Text;
                        String sDataType = ugrFilter.Cells[4].Text;

                        if (sFldName == "" || sMatch == "" || sValue == "") continue;

                        sFldName = "[" + sFldName + "]";
                        switch (sDataType)
                        {
                            case "T":
                                sFldName = "'" + sFldName + "'";
                                //if (sValue.Substring(0, 1) != "[" && sValue.Substring(sValue.Length-1,1) != "]") sValue = "'" + sValue + "'";
                                sValue = "'" + sValue + "'";
                                break;
                            case "N":
                                break;
                            default:
                                break;
                        }

                        sCond = sFldName + sMatch + sValue;
                        switch (sAndOr)
                        {
                            case "and":
                                switch (pAndOr)
                                {
                                    case "and":
                                        sFilter = sFilter + "," + sCond;
                                        break;
                                    case "or":
                                        sFilter = sFilter + "," + sAND + sCond;
                                        break;
                                    default:
                                        sFilter = sFilter + sAND + sCond;
                                        break;
                                }
                                break;
                            case "or":
                                if (!bHasOR)
                                {
                                    bHasOR = true;
                                    sFilter = sOR + sFilter;
                                }
                                switch (pAndOr)
                                {
                                    case "and":
                                        sFilter = sFilter + "," + sCond + ")";
                                        break;
                                    case "or":
                                        sFilter = sFilter + "," + sCond;
                                        break;
                                    default:
                                        sFilter = sFilter + sCond;
                                        break;
                                }
                                break;
                            default:
                                switch (pAndOr)
                                {
                                    case "and":
                                        sFilter = sFilter + "," + sCond + ")";
                                        break;
                                    case "or":
                                        sFilter = sFilter + "," + sCond + ")";
                                        break;
                                    default:
                                        sFilter = sAND + sCond + ")";
                                        break;
                                }
                                break;
                        }
                        p2AndOr = pAndOr;
                        pAndOr = sAndOr;
                    }
                    if (bHasOR && p2AndOr == "and") sFilter = sFilter + ")";

                    if (sFilter == "")
                    {
                        dtValues = SessionWrapper.QueryDataset;
                    }
                    else
                    {
                        //check each row against the filter
                        SessionWrapper.FilteredDataset = SessionWrapper.QueryDataset.Clone();
                        foreach (DataRow drDatasetRow in SessionWrapper.QueryDataset.Rows)
                        {
                            String sCalcFilter = sFilter;
                            foreach (UltraGridRow ugrFilter in ugFilter.Rows)
                            {
                                String sCondCol = "Cond_" + iCond.ToString();
                                String sField = "[" + ugrFilter.Cells[0].Text + "]";
                                String sValue = ugrFilter.Cells[2].Text;
                                String sDataType = ugrFilter.Cells[4].Text;

                                String sFldName = sField.Substring(1, sField.Length - 2);
                                sCalcFilter = sCalcFilter.Replace(sField, drDatasetRow[sFldName].ToString());
                                if (sValue.Substring(0, 1) == "[" && sValue.Substring(sValue.Length-1, 1) == "]")
                                {
                                    String sValFld = sValue.Substring(1, sValue.Length - 2);
                                    sCalcFilter = sCalcFilter.Replace(sValue, drDatasetRow[sValFld].ToString());
                                }
                            }

                            Boolean bFilter = false;
                            try
                            {
                                bFilter = UltraWebCalcManager1.Calculate(sCalcFilter).ToBoolean();
                            }
                            catch (Exception ex)
                            {
                                bFilter = false;
                                bFilterFailed = true;
                                hidFilterFailed.Value = "An error occured in your filter.  Please check and try again.";
                                break;
                            }

                            if (bFilter)
                            {
                                DataRow row = SessionWrapper.FilteredDataset.NewRow();
                                row.ItemArray = drDatasetRow.ItemArray;
                                SessionWrapper.FilteredDataset.Rows.Add(row);
                            }
                        }

                        dtValues = (bFilterFailed) ? SessionWrapper.QueryDataset : SessionWrapper.FilteredDataset;
                    }
                }
                else
                {
                    DataTable dtDataset = (hidFilter.Value == "Filter") ? SessionWrapper.FilteredDataset: SessionWrapper.QueryDataset;
                    if (bPivot)
                    {
                        DataTable dtRows = new DataTable();
                        DataTable dtRow2Col = new DataTable();
                        String s0thCol = "Code";
                        String s1stCol = "";
                        String sConst = "";
                        String sFldName = "";

                        //Get Field properties
                        DataColumn[] keys = new DataColumn[1];
                        DataColumn column = new DataColumn();
                        column.ColumnName = "Code";
                        column.DataType = typeof(String);
                        keys[0] = column;
                        DataTable dtRowProps = new DataTable();
                        dtRowProps.Columns.Add(column);
                        dtRowProps.Columns.Add("DataPoint", typeof(Int32));
                        dtRowProps.Columns.Add("Format", typeof(String));
                        dtRowProps.PrimaryKey = keys;
                        switch (iQueryType)
                        {
                            case 1:
                                dtRows = SessionWrapper.QueryColumns;
                                s1stCol = "Field";
                                sConst = ddlPeriods.DataValue.ToString();
                                break;
                            case 2:
                                dtRows = SessionWrapper.QueryColumns;
                                s1stCol = "Field";
                                sConst = ddlCompany.DataValue.ToString();
                                break;
                            case 3:
                                dtRows = GetData.GetFieldProperties(Convert.ToInt32(ddlField.DataValue));
                                s1stCol = "Year";
                                sConst = ddlField.DataValue.ToString();
                                sFldName = ddlField.DisplayValue;
                                break;
                        }
                        foreach (DataRow drRows in dtRows.Rows)
                        {
                            DataRow row = dtRowProps.NewRow();
                            row["Code"] = drRows["Text"].ToString();
                            row["DataPoint"] = Convert.ToInt32(drRows["Value"]);
                            row["Format"] = "{" + drRows["DataType"].ToString() + drRows["Decimals"].ToString() + "}";
                            dtRowProps.Rows.Add(row);
                        }

                        //Generate Column list from existing Rows
                        dtValues.Columns.Add(s0thCol);
                        dtValues.Columns.Add(s1stCol);
                        foreach (DataRow drRow2Col in dtDataset.Rows)
                        {
                            dtValues.Columns.Add(drRow2Col[1].ToString());
                        }

                        //Read Columns to make new Rows, skipping the first two
                        iCols = 0;
                        foreach (DataColumn drCol in dtDataset.Columns)
                        {
                            iCols++;
                            if (iCols > 2)
                            {
                                DataRow row = dtValues.NewRow();
                                String sColName = drCol.ColumnName;
                                String sPropCol = (iQueryType == 3) ? sFldName : drCol.ColumnName;
                                String sColFrmt = "{T0}";
                                String sCode = "";
                                //DataRow drRowProd = dtRowProps.Rows.Find(sColName);
                                DataRow drRowProd = dtRowProps.Rows.Find(sPropCol);
                                if (drRowProd != null)
                                {
                                    sColFrmt = drRowProd["Format"].ToString();
                                    sCode = (iQueryType == 3) ? sFldName : drRowProd["Code"].ToString();
                                }

                                //Read each Row and get Column [iCols] for the value
                                row[0] = "{T0}" + sCode;
                                row[1] = "{T0}" + sColName;
                                iRows = 1;
                                foreach (DataRow drRow in dtDataset.Rows)
                                {
                                    iRows++;
                                    row[iRows] = sColFrmt + drRow[iCols - 1].ToString();
                                }
                                dtValues.Rows.Add(row);
                            }
                        }
                    }
                    else
                    {
                        dtValues = dtDataset;
                    }
                }

                iElementCount = iRows * iCols;

                ugQryResults.DataSource = dtValues;
            }
        }

        protected void warpQryResults_ContentRefresh(object sender, EventArgs e)
        {
            iQueryType = Convert.ToInt32(ddlQueryType.DataValue);
            bPivot = (wibPivot.Text == "Pivot: ON");
            bShowTotals = (wibShowTotals.Text == "Totals: ON");
            ugQryResults.DataBind();
        }

        protected void warpFilter_ContentRefresh(object sender, EventArgs e)
        {
            if (hidFilter.Value == "Clear")
            {
                ugFilter.Clear();

                DataTable dtFieldList = new DataTable();
                dtFieldList.Columns.Add("Text", typeof(String));
                dtFieldList.Columns.Add("Value", typeof(String));
                dtFieldList.Columns.Add("DataType", typeof(String));
                foreach (DataRow drCols in SessionWrapper.QueryColumns.Rows)
                {
                    DataRow row = dtFieldList.NewRow();
                    row["Text"] = drCols["Text"].ToString();
                    row["Value"] = "[" + drCols["Text"].ToString() + "]";
                    row["DataType"] = drCols["DataType"].ToString();
                    dtFieldList.Rows.Add(row);
                }

                ddlFieldList.DataSource = dtFieldList;
                ddlFieldList.DataTextField = "Text";
                ddlFieldList.DataValueField = "Value";
                ddlFieldList.DataBind();
                ddlFieldList.Columns[1].Hidden = true;
                ddlFieldList.Columns[2].Hidden = true;
                ddlFieldList.SelectedIndex = -1;

                ddlValueList.DataSource = dtFieldList;
                ddlValueList.DataTextField = "Text";
                ddlValueList.DataValueField = "Value";
                ddlValueList.DataBind();
                ddlValueList.Columns[1].Hidden = true;
                ddlValueList.Columns[2].Hidden = true;
                ddlValueList.SelectedIndex = -1;

                ddlMatch.DataSource = Util.GetFilterCriteria();
                ddlMatch.DataTextField = "Value";
                ddlMatch.DataValueField = "Text";
                ddlMatch.DataBind();
                ddlMatch.Columns[1].Hidden = true;
                ddlMatch.SelectedIndex = -1;

                ddlAndOr.DataSource = Util.GetFilterAndOr();
                ddlAndOr.DataTextField = "Text";
                ddlAndOr.DataValueField = "Text";
                ddlAndOr.DataBind();
                ddlAndOr.Columns[1].Hidden = true;
                ddlAndOr.SelectedIndex = -1;

                ugFilter.Columns[0].ValueList.WebCombo = ddlFieldList;
                ugFilter.Columns[1].ValueList.WebCombo = ddlMatch;
                ugFilter.Columns[3].ValueList.WebCombo = ddlAndOr;
            }
        }

        protected void wibExportExcel_Click(object sender, Infragistics.WebUI.WebDataInput.ButtonEventArgs e)
        {
            UltraWebGridExcelExporter1.DownloadName = "report.xls";
            UltraWebGridExcelExporter1.Export(this.ugQryResults);
        }

        protected void warpGroupName_ContentRefresh(object sender, EventArgs e)
        {
            if (GetData.GroupExists("CompanyGroupNames", txtGroupName.Text, "0"))
            {
                hidGroupExists.Value = "Yes";
            }
            else
            {
                hidGroupExists.Value = "";
    
                string connectionString = Settings.GetDatabaseConnectionString(iDBID);
                using (SqlConnection myConnection = new SqlConnection(connectionString))
                {
                    myConnection.Open();

                    using (SqlCommand cmd = new SqlCommand())
                    {
                        StringBuilder sbContent = new StringBuilder();
                        String sID = GetData.GetNextCompGroupID("0");
                        sbContent.AppendLine("insert into CompanyGroupNames (GroupID, Description, PrivacyLevelID, UserID, CreatorID) values (" + sID + ",'" + txtGroupName.Text + "',0," + sUserID + "," + sUserID + ");");

                        int iSeq = 0;
                        foreach (UltraGridRow ugrQryRes in ugQryResults.Rows)
                        {
                            String sCode = ugrQryRes.Cells[0].Value.ToString();
                            if (sCode != "")
                            {
                                iSeq++;
                                sbContent.AppendLine("insert into CompanyGroup (GroupID, Code, Sequence) values (" + sID + ",'" + sCode + "'," + iSeq.ToString() + ");");
                            }
                        }

                        String qryCompanyGroup = sbContent.ToString();
                        cmd.Connection = myConnection;
                        cmd.CommandText = qryCompanyGroup;
                        cmd.CommandType = System.Data.CommandType.Text;
                        cmd.ExecuteNonQuery();
                    }
                }
            }
        }
    }
}
